#include "stdafx.h"


///////////////////////////////////////////
//this function loads evaluation function parameters 
//from (9) files
///////////////////////////////////////////
bool LoadParameters()
{
	
	FILE *file;
	//there must be at largest 4-digited parameteres
	//where, hence, the 5th symbol is the end symbol of the string
	char param[5];
	int i=0,
		k=0;
	
//Loading process.
//Files required are 1.txt
//					 2.txt
//					 ...
//					 9.txt
//with their full path
////////////////////////////////////////////////
	file=fopen("c:\\temp\\1.txt","r");

	if(!file)
	{
		printf("Open error 1\n");
		return false;
	}
	
	param[0]='\0';

	while(fgets(param,5,file))
	{
		k=0;
		while (param[k] >= '0' && param[k] <='9') 
		{
			Chromosome[0][i] = (Chromosome[0][i]*10) + (param[k] - '0');
			k++;
		}
		i++;
	}
	
	fclose(file);
////////////////////////////////////////////////

////////////////////////////////////////////////
	file=fopen("c:\\temp\\2.txt","r");

	if(!file)
	{
		printf("Open error 2\n");
		return false;
	}
	
	param[0]='\0';
	i = 0;
	while(fgets(param,5,file))
	{
		k=0;
		while (param[k] >= '0' && param[k] <='9') 
		{
			Chromosome[1][i] = (Chromosome[1][i]*10) + (param[k] - '0');
			k++;
		}
		i++;
	}
	
	fclose(file);
////////////////////////////////////////////////

////////////////////////////////////////////////
	file=fopen("c:\\temp\\3.txt","r");

	if(!file)
	{
		printf("Open error 3\n");
		return false;
	}
	
	param[0]='\0';
	i = 0;
	while(fgets(param,5,file))
	{
		k=0;
		while (param[k] >= '0' && param[k] <='9') 
		{
			Chromosome[2][i] = (Chromosome[2][i]*10) + (param[k] - '0');
			k++;
		}
		i++;
	}
	
	fclose(file);
////////////////////////////////////////////////

////////////////////////////////////////////////
	file=fopen("c:\\temp\\4.txt","r");

	if(!file)
	{
		printf("Open error 4\n");
		return false;
	}
	
	param[0]='\0';
	i = 0;
	while(fgets(param,5,file))
	{
		k=0;
		while (param[k] >= '0' && param[k] <='9') 
		{
			Chromosome[3][i] = (Chromosome[3][i]*10) + (param[k] - '0');
			k++;
		}
		i++;
	}
	
	fclose(file);
////////////////////////////////////////////////

////////////////////////////////////////////////
	file=fopen("c:\\temp\\5.txt","r");

	if(!file)
	{
		printf("Open error 5\n");
		return false;
	}
	
	param[0]='\0';
	i = 0;
	while(fgets(param,5,file))
	{
		k=0;
		while (param[k] >= '0' && param[k] <='9') 
		{
			Chromosome[4][i] = (Chromosome[4][i]*10) + (param[k] - '0');
			k++;
		}
		i++;
	}
	
	fclose(file);
////////////////////////////////////////////////

////////////////////////////////////////////////
	file=fopen("c:\\temp\\6.txt","r");

	if(!file)
	{
		printf("Open error 6\n");
		return false;
	}
	
	param[0]='\0';
	i = 0;
	while(fgets(param,5,file))
	{
		k=0;
		while (param[k] >= '0' && param[k] <='9') 
		{
			Chromosome[5][i] = (Chromosome[5][i]*10) + (param[k] - '0');
			k++;
		}
		i++;
	}
	
	fclose(file);
////////////////////////////////////////////////

////////////////////////////////////////////////
	file=fopen("c:\\temp\\7.txt","r");

	if(!file)
	{
		printf("Open error 7\n");
		return false;
	}
	
	param[0]='\0';
	i = 0;
	while(fgets(param,5,file))
	{
		k=0;
		while (param[k] >= '0' && param[k] <='9') 
		{
			Chromosome[6][i] = (Chromosome[6][i]*10) + (param[k] - '0');
			k++;
		}
		i++;
	}
	
	fclose(file);
////////////////////////////////////////////////

////////////////////////////////////////////////
	file=fopen("c:\\temp\\8.txt","r");

	if(!file)
	{
		printf("Open error 8\n");
		return false;
	}
	
	param[0]='\0';
	i = 0;
	while(fgets(param,5,file))
	{
		k=0;
		while (param[k] >= '0' && param[k] <='9') 
		{
			Chromosome[7][i] = (Chromosome[7][i]*10) + (param[k] - '0');
			k++;
		}
		i++;
	}
	
	fclose(file);
////////////////////////////////////////////////

////////////////////////////////////////////////
	file=fopen("c:\\temp\\9.txt","r");

	if(!file)
	{
		printf("Open error 9\n");
		return false;
	}
	
	param[0]='\0';
	i = 0;
	while(fgets(param,5,file))
	{
		k=0;
		while (param[k] >= '0' && param[k] <='9') 
		{
			Chromosome[8][i] = (Chromosome[8][i]*10) + (param[k] - '0');
			k++;
		}
		i++;
	}
	
	fclose(file);
////////////////////////////////////////////////

return true;
}


///////////////////////////////////////////
//this function creates a random set of parameters for POP individuals
//(was used in testing)
///////////////////////////////////////////
void CreateParameters(void)
{
	float r = 0;

	for(int i = 0;i < POP; i++)
		for (int j =0; j < 26; j++)
		{
			r = ((float)rand())/((float)(RAND_MAX));
			Chromosome[i][j] = (int)(r*((float)LocalMax(j)) + (1-r)*((float)LocalMin(j)));
		}
}


///////////////////////////////////////////
//this function shows evaluation function parameters
///////////////////////////////////////////
void ShowParameters(void)
{
	for(int i = 0;i < POP; i++)
		for (int j =0; j < 26; j++)
			printf("Chromosome[%d][%d]=%d\n",i,j,Chromosome[i][j]);
}


///////////////////////////////////////////
//this function creates new generation
//and writes it to NewChromosome
///////////////////////////////////////////
void MakeNewGeneration(void)
{
		  //see thesis for the description
	float TotalFitness = 0,
		  SelectionProb[POP],
		  CumProb[POP];

	int i = 0;

	//total (population) fitness
	for (i = 0; i < POP; i++)
		TotalFitness += Fitness[i];

	//Selection Probability
	for (i = 0; i < POP; i++)
	{
		SelectionProb[i] = Fitness[i]/TotalFitness;
		printf("SelectionProb[%d]=%f\n",i,SelectionProb[i]);
	}

	//Cumulative Probability
	for (i = 0; i < POP; i++)
	{
		CumProb[i] = 0;
		for (int j = 0; j<i+1; j++)
			CumProb[i] += SelectionProb[j];

		printf("CumProb[%d]=%f\n",i,CumProb[i]);
	}

	//Selection
	float r;

	for (int a = 0; a < POP ; a++)
		{
			r = ((float)rand())/((float)(RAND_MAX));
	
			i = 0;
			while ((r > CumProb[i]) && (i < (POP-1)))
				i++;
	
			NewPopulation[a] = i;
			printf("NewPopulation[%d]=%d\n",a,NewPopulation[a]);
		}

	for (i = 0; i < POP; i++)
		for (int j = 0; j < 26; j++)
			NewChromosome[i][j] = Chromosome[NewPopulation[i]][j];
}


///////////////////////////////////////////
//this function selects pairs for the crossover
///////////////////////////////////////////
void MakeSelection(void)
{
	float r;
	int k = 0;

	int Aux[POP+1];
	int tmp = 0;

	for (int i = 0; i < (POP+1); i++)
	{
		SelectedPairs[i] = -1;
		Aux[i] = i;
	}

	for (i = 0; i < POP; i++)
	{
		r = ((float)rand())/((float)(RAND_MAX));

		if (r < Pc)
		{
			//choose a chromosome for the crossover
			do 
			{
				tmp = (rand())%(POP);
			}
			while (Aux[tmp] == -1);

			SelectedPairs[k] = Aux[tmp];
			Aux[tmp] = -1;
			k++;
		}
	}

	//makes full pairing if necessary
	if ((k%2) == 1)
	{
		if ((rand()%2) == 0)
			SelectedPairs[k-1] = -1;
		else
		{
			do 
			{
				tmp = (rand())%(POP);
			}
			while (Aux[tmp] == -1);

			SelectedPairs[k] = tmp;
		}

	}
	
	//visualisation
	for(i = 0; i<(POP+1);i++)
		printf("SelectedPairs[%d]=%d\n",i,SelectedPairs[i]);
}


///////////////////////////////////////////
//this function performs the crossover
//(see thesis for the description)
///////////////////////////////////////////
void Crossover (void)
{
	int PointRight = 0,
		PointLeft = 0,
		
		k = 0;
	
	float a = ((float)rand())/((float)(RAND_MAX));
	
	printf("a=%f\n",a);
	
	float tmp = 0;

	//Define edges
	while (PointLeft == PointRight)
	{
		PointRight = (rand())%26,
		PointLeft  = (rand())%26;

		if (PointRight < PointLeft)
		{
			int temp = 0;
			temp = PointLeft;
			PointLeft = PointRight;
			PointRight = temp;
		}
	}

	printf("PointLeft=%d, PointRight=%d\n",PointLeft,PointRight);

	int Pairs = 1;
	while ((SelectedPairs[Pairs] != -1) && (Pairs < 10))
		Pairs = Pairs + 2;
	
	Pairs = Pairs - 2;

	while (Pairs > 0)
	{	
	
		int Tmp1[26],
			Tmp2[26];

		for (int i = 0; i < 26; i++)
		{
			Tmp1[i] = 0;
			Tmp2[i] = 0;
		}
	
		for (i = 0; i<=PointLeft; i++)
		{
			//floor(2.8) --> 2
			//ceil(2.8) --> 3
			tmp = (a*((float)NewChromosome[SelectedPairs[Pairs-1]][i]) + (1-a)*((float)NewChromosome[SelectedPairs[Pairs]][i]));
			if ((tmp - (float)floor((double)tmp)) < (float)0.5)
				Tmp1[i] = (int)floor((double)tmp);
			else 
				Tmp1[i] = (int)ceil((double)tmp);

			tmp = (a*((float)NewChromosome[SelectedPairs[Pairs]][i]) + (1-a)*((float)NewChromosome[SelectedPairs[Pairs-1]][i]));
			if ((tmp - (float)floor((double)tmp)) < (float)0.5)
				Tmp2[i] = (int)floor((double)tmp);
			else 
				Tmp2[i] = (int)ceil((double)tmp);
		}

		for (i = PointLeft+1; i < PointRight; i++)
		{
			tmp = (a*((float)NewChromosome[SelectedPairs[Pairs-1]][i]) + (1-a)*((float)NewChromosome[SelectedPairs[Pairs]][i]));
			if ((tmp - (float)floor((double)tmp)) < (float)0.5)
				Tmp2[i] = (int)floor((double)tmp);
			else 
				Tmp2[i] = (int)ceil((double)tmp);

			tmp = (a*((float)NewChromosome[SelectedPairs[Pairs]][i]) + (1-a)*((float)NewChromosome[SelectedPairs[Pairs-1]][i]));
			if ((tmp - (float)floor((double)tmp)) < (float)0.5)
				Tmp1[i] = (int)floor((double)tmp);
			else 
				Tmp1[i] = (int)ceil((double)tmp);
		}

		for (i = PointRight; i < 26; i++)
		{
			tmp = (a*((float)NewChromosome[SelectedPairs[Pairs-1]][i]) + (1-a)*((float)NewChromosome[SelectedPairs[Pairs]][i]));
			if ((tmp - (float)floor((double)tmp)) < (float)0.5)
				Tmp1[i] = (int)floor((double)tmp);
			else 
				Tmp1[i] = (int)ceil((double)tmp);

			tmp = (a*((float)NewChromosome[SelectedPairs[Pairs]][i]) + (1-a)*((float)NewChromosome[SelectedPairs[Pairs-1]][i]));
			if ((tmp - (float)floor((double)tmp)) < (float)0.5)
				Tmp2[i] = (int)floor((double)tmp);
			else 
				Tmp2[i] = (int)ceil((double)tmp);
		}

		for (i = 0; i < 26; i++)
		{
			NewChromosome[SelectedPairs[Pairs-1]][i] = Tmp1[i];
			NewChromosome[SelectedPairs[Pairs]][i] = Tmp2[i];
		}

		Pairs = Pairs - 2;
	}

}

///////////////////////////////////////////
//this function provides the mutation
//(see thesis for the description)
///////////////////////////////////////////
void Mutation()
{

	float a = 0;

	for (int i = 0; i < POP; i++)
		for (int j = 0; j < 26; j++)
		{
			a = ((float)rand())/((float)(RAND_MAX));			
			if (a < Pm)
			{
				printf("Mutation for %d,%d\n",i,j);
				NewChromosome[i][j] = Mutate(j);
			}
		}
}


///////////////////////////////////////////
//this function performs the mutation of a parameter
//(see thesis for the description)
///////////////////////////////////////////
int Mutate (int j)
{
	float temp = 0;

	temp = ((float)rand())/((float)(RAND_MAX));

	int ret = (int)(temp*((float)LocalMax(j)) + (1-temp)*((float)LocalMin(j)));

	if ( (rand()%2) == 1)
		ret = (int)((1-temp)*((float)LocalMax(j)) + temp*((float)LocalMin(j)));
	
	return ret;
}


///////////////////////////////////////////
//auxiliary function
//returns the maximal possible value of a given parameter
//assumes correct input, i.e. 0 <= j =< 25
///////////////////////////////////////////
int LocalMax(int j)
{
	if (j == 0)
		return 1000;

	if (j == 1)
		return 540;

	if (j == 2)
		return 370;

	if (j == 3)
		return 360;

	if (j == 4)
		return 115;

	if (j == 5)
		return 40;

	if (j == 6)
		return 40;

	if (j == 7)
		return 50;

	if (j == 8)
		return 30;

	if (j == 9)
		return 30;

	if (j == 10)
		return 20;

	if (j == 11)
		return 30;

	if (j == 12)
		return 40;

	if (j == 13)
		return 30;

	if (j == 14)
		return 30;

	if (j == 15)
		return 5;

	if (j == 16)
		return 40;

	if (j == 17)
		return 40;

	if (j == 18)
		return 30;

	if (j == 19)
		return 30;

	if (j == 20)
		return 30;

	if (j == 21)
		return 15;

	if (j == 22)
		return 20;

	if (j == 23)
		return 20;

	if (j == 24)
		return 30;

	if (j == 25)
		return 30;

}

///////////////////////////////////////////
//auxiliry function
//returns the minimal possible value of a given parameter
//assumes correct input, i.e. 0 <= j =< 25
///////////////////////////////////////////
int LocalMin(int j)
{
	if (j == 0)
		return 800;

	if (j == 1)
		return 440;

	if (j == 2)
		return 300;

	if (j == 3)
		return 290;

	if (j == 4)
		return 85;

	if (j == 5)
		return 0;

	if (j == 6)
		return 0;

	if (j == 7)
		return 0;

	if (j == 8)
		return 0;

	if (j == 9)
		return 0;

	if (j == 10)
		return 0;

	if (j == 11)
		return 0;

	if (j == 12)
		return 0;

	if (j == 13)
		return 0;

	if (j == 14)
		return 0;

	if (j == 15)
		return 0;

	if (j == 16)
		return 0;

	if (j == 17)
		return 0;

	if (j == 18)
		return 0;

	if (j == 19)
		return 0;

	if (j == 20)
		return 0;

	if (j == 21)
		return 0;

	if (j == 22)
		return 0;

	if (j == 23)
		return 0;

	if (j == 24)
		return 0;

	if (j == 25)
		return 0;

}


///////////////////////////////////////////
//this function shows both old and new generations
///////////////////////////////////////////
void ShowNewGen()
{
	for (int i = 0; i < POP; i++)
		for (int j = 0; j < 26; j++)
			printf("Old[%d][%d]=%d, New[%d][%d]=%d\n",i,j,Chromosome[i][j],i,j,NewChromosome[i][j]);
}
