struct Params 
	{
		int fromSquare,
			dep,
			toSquare,
			dest,
			MoveType,
			EnPassant,
			MovingSide;
		
		bool WhiteLongCastling,
			 WhiteShortCastling,
			 BlackLongCastling,
			 BlackShortCastling,
			 WhiteCastlingDone,
			 BlackCastlingDone;
	};

extern int BestFromSquare,
		   BestToSquare;

///////////////////////////////////////////
void MoveBack(Params);

///////////////////////////////////////////
int FullSearch(int PliesToSearch);

///////////////////////////////////////////
int AB_Search(int PliesToSearch, int a, int b);

///////////////////////////////////////////
int FindMove(int PliesToSearch);

///////////////////////////////////////////
bool isInTransTable(int PrHashKey, int SecHashKey, int PliesToSearch);

///////////////////////////////////////////
void AddToTransTable(int PrimaryHashKey, int SecondaryHashKey, int Score, int Depth);

///////////////////////////////////////////
void GenerateMoves(aMove*, int);

///////////////////////////////////////////
void ShowMoves(aMove*);

///////////////////////////////////////////
void ShowHistory(void);

///////////////////////////////////////////
void AutoPlay(int Depth);