#include "stdafx.h"

int main(int argc, char* argv[])
{

	//fitness values are assigned manually
	Fitness[0] = ((float)8.5/(float)(2*POP));
	Fitness[1] = ((float)10.5/(float)(2*POP));
	Fitness[2] = ((float)8/(float)(2*POP));
	Fitness[3] = ((float)7/(float)(2*POP));
	Fitness[4] = ((float)11/(float)(2*POP));
	Fitness[5] = ((float)5.5/(float)(2*POP));
	Fitness[6] = ((float)7.5/(float)(2*POP));
	Fitness[7] = ((float)11.5/(float)(2*POP));
	Fitness[8] = ((float)9.5/(float)(2*POP));


	//visualisation
	for (int i = 0; i < POP; i++)
		printf("Fitness[%d]=%f\n",i,Fitness[i]);

	//random numbers generator
	srand( (unsigned)time( NULL ) );

	//you can load parameters from files
	//LoadParameters();
	
	//or create a random set
	CreateParameters();
	
	//visualisation
	//ShowParameters();

	//Select new individuals, according to their fitness
	//by means of roulette wheel (see thesis)
	MakeNewGeneration();
	
	//Select chromosomes for the crossover
	MakeSelection();
	
	//Apply genetic operators
	Crossover();
	Mutation();
	
	//Show results
	ShowNewGen();

	getchar();
	return 0;
}


